---@type Tinkr, Bastion
local Tinkr, Bastion = ...

---@alias itemId integer

-- Create a new ItemBook class
---@class Bastion.ItemBook
---@field items table<itemId, Bastion.Item>
local ItemBook = {}
ItemBook.__index = ItemBook

-- Constructor
---@return Bastion.ItemBook
function ItemBook:New()
    local self = setmetatable({}, ItemBook)
    self.items = {}
    return self
end

-- Get a spell from the ItemBook
---@param id number
---@return Bastion.Item
function ItemBook:GetItem(id)
    if self.items[id] == nil then
        self.items[id] = Bastion.Item:New(id)
    end

    return self.items[id]
end

return ItemBook
